﻿using System.Collections.Generic;
using System.Diagnostics;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace PixelShaderTest
{
    public class Game1 : Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        private Vector2 position, speed;
        private Texture2D texture;
        private int index = 0;
        private List<Effect> effects = new List<Effect>();
        private KeyboardState prevState;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        protected override void Initialize()
        {
            position = new Vector2(320, 150);
            speed = new Vector2(1, 1);

            base.Initialize();
        }

        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            texture = Content.Load<Texture2D>("logo");
            effects.Add(Content.Load<Effect>("defaultEffect"));
            effects.Add(Content.Load<Effect>("greyEffect"));
            effects.Add(Content.Load<Effect>("gameboyEffect"));
        }

        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        protected override void Update(GameTime gameTime)
        {
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed || Keyboard.GetState().IsKeyDown(Keys.Escape))
                Exit();

            position += speed;

            if (position.X > 500)
                speed.X = -1;
            if (position.Y > 300)
                speed.Y = -1;
            if (position.X < 50)
                speed.X = 1;
            if (position.Y < 20)
                speed.Y = 1;

            KeyboardState kbState = Keyboard.GetState();
            if (kbState.IsKeyDown(Keys.Space) && !prevState.IsKeyDown(Keys.Space))
            {
                index = (index == 2) ? 0 : index + 1;
            }
            prevState = kbState;

            base.Update(gameTime);
        }

        protected override void Draw(GameTime gameTime)
        {
            if(index == 2)
                GraphicsDevice.Clear(new Color(0, 0.1f, 0));
            else
                GraphicsDevice.Clear(Color.Black);

            spriteBatch.Begin(SpriteSortMode.Deferred, BlendState.NonPremultiplied, 
                SamplerState.PointClamp, DepthStencilState.Default, RasterizerState.CullNone, effects[index]);
            spriteBatch.Draw(texture, position, Color.White);
            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}
